var net = require('net');
var peerList = [];
var socketMap = {};

var messageHandlers = {
  identify: function(message, socket){
    var remoteAddress = {host: socket.remoteAddress, port: message.data.port};
    socket.write(JSON.stringify({type:'listPeers', data: {peers: peerList}}));
    peerList.push(remoteAddress);
    for(var i in socketMap){
      socketMap[i].write(JSON.stringify({type:'addPeer', data:{peer: remoteAddress}}));
    }
    socketMap[remoteAddress] = socket;
  }
}

var tcp = net.createServer(function (socket) {
  
  socket.on('data', function(message){
    message = JSON.parse(message.toString());
    messageHandlers[message.type](message, socket);
  });
    
});

tcp.listen(8124);